/*
 * $RCSfile: lcp_i.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1994  Arizona Board of Regents
 *
 * $Log: lcp_i.h,v $
 * Revision 1.1  1994/10/24 20:46:02  andrey
 * Initial revision
 *
 *
 * $Revision: 1.1 $
 * $Date: 1994/10/24 20:46:02 $
 */

/*
 * lcp internal state defs
 */

/* ------------------- Protocol headers ---------------------------------- */
typedef struct
{
  u_short	prot;
} PROT_REJ_header;

typedef struct
{
  u_long		magic_num;
} ECHO_header;

#define	LCP_CODE_REJ_init(header_ptr) ((header_ptr)->code=LCP_CODE_REJ)
#define	LCP_PROT_REJ_init(header_ptr) ((header_ptr)->code=LCP_PROT_REJ)
#define	LCP_ECHO_REQ_init(header_ptr) ((header_ptr)->code=LCP_ECHO_REQ)
#define	LCP_ECHO_REP_init(header_ptr) ((header_ptr)->code=LCP_ECHO_REP)
#define	LCP_DISC_REQ_init(header_ptr) ((header_ptr)->code=LCP_DISC_REQ)

/*
 * configuration options packet defs
 */

typedef struct
{
  u_short	mru;
} MRU_opt;

#define	MRU_opt_init(opt_ptr) ((opt_ptr)->type=LCP_MRU, (opt_ptr)->length=4)

typedef struct
{
  u_long		accm;
} ACCM_opt;

#define	ACCM_opt_init(opt_ptr) ((opt_ptr)->type=LCP_ACCM, (opt_ptr)->length=6)

typedef struct
{
  u_short 	auth_prot;
} AUTH_opt;

/* length needs to be set- this is a variably-sized packet */
#define	AUTH_opt_init(opt_ptr) ((opt_ptr)->type=LCP_AUTH, (opt_ptr)->length=4)

typedef struct
{
  u_short	quality_prot;
} QUAL_opt;

/* length needs to be set- this is a variably-sized packet */
#define	QUAL_opt_init(opt_ptr) ((opt_ptr)->type=LCP_QUAL, (opt_ptr)->length=4)

typedef struct
{
  u_long		magic_number;
} MAGIC_opt;

#define	MAGIC_opt_init(opt_ptr) ((opt_ptr)->type=LCP_MAGIC, (opt_ptr)->length=6)

typedef PPP_opt COMPRS_opt;

#define	PFC_opt_init(opt_ptr) ((opt_ptr)->type=LCP_PFC, (opt_ptr)->length=2)

#define	ACFC_opt_init(opt_ptr) ((opt_ptr)->type=LCP_ACFC, (opt_ptr)->length=2)

/* ------------------- XObj Protocol specific stuff ----------------------- */

typedef struct {
  PPP_config  implem_options;	/* implementation options */
  PPP_options rom_lcp_options;	/* rom file options */
  XObj	TheSession;		/* the only session */
} PSTATE;

#define	PSTATE_init(PSTATE_ptr)\
	{\
          PPP_config_init(&((PSTATE_ptr)->implem_options));\
	  PPP_options_init(&((PSTATE_ptr)->rom_lcp_options));\
          (PSTATE_ptr)->TheSession = ERR_XOBJ;\
        }

/* ------------------- XObj Session specific stuff ----------------------- */

typedef struct {
  u_long magic_number;

  PPP_options * my_agreed_options;	/* options that are ok */
  PPP_options * my_nego_options;	/* options still in negotiation */
  PPP_options * my_un_nego_options;	/* rejected options */

  PPP_options * peer_agreed_options;	/* options that are ok */
  PPP_options * peer_nego_options;	/* options still in negotiation */
  PPP_options * peer_un_nego_options;	/* rejected options */

  u_char code_reject_id;
  FSM_info * lcp_fsm;
} SSTATE;
