/*     
 * $RCSfile: prottbl_parse.c,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: prottbl_parse.c,v $
 * Revision 1.2.1.1  1994/06/10 20:43:10  menze
 * Changed xProtocolTableEntries declaration
 *
 * Revision 1.2  1994/05/15  00:20:08  davidm
 * Fixed RCS log.
 *
 * Revision 1.1  1994/05/15  00:19:47  davidm
 * Initial revision
 */


#include "prottbl.h"

typedef struct {
    char	*name;
    long	relNum;
} MapEntry;


typedef struct {
    char 	*name;
    long	id;
    MapEntry	*map;
} Entry;

extern const Entry *xProtocolTableEntries;

int
protTblParse( s )
    char *s;
{
    static int	done = 0;
    const Entry *e;
    MapEntry	*mapEnt;

    printf("protTblParse called\n");
    if ( ! done ) {
	done = 1;
	for ( e = xProtocolTableEntries; e->name; e++ ) {
	    protTblAddProt(e->name, e->id);
	    if ( e->map ) {
		for ( mapEnt = e->map; mapEnt->name; mapEnt ++ ) {
		    protTblAddBinding(e->name, mapEnt->name, mapEnt->relNum);
		}
	    }
	}
    }
    return 0;
}


